package com.jdbernard.timeanalyzer

public class DescriptionBasedCategorizationPlan implements CategorizationPlan {

    public boolean deservesNewCategory(Event event, List<Entry> existingEntries) {
        return existingEntries.findAll {
            it.description == event.description }.size() > 0
    }

    public Category newCategory(Event event,
    List<Entry> existingEntries) {
        return new DescriptionBasedCategory(event.description)
    }

    public List<Entry> findEntriesToRecategorize(Event event,
    List<Entry> existingEntries) {
        return existingEntries.findAll { it.description == event.description }
    }

}
